#include "Max.h"
#include <stdio.h>
#include <direct.h>
#include <notify.h>
#include <commdlg.h>
#include <3dsmaxport.h>
#include <stdmat.h>
#include <iparamb2.h>
#include <iskin.h>
#if MAX_API_NUM <= 33	// 2010
#include <maxscrpt/maxscrpt.h>
#include <maxscrpt/Listener.h>
#include <maxscrpt/numbers.h>
#include <maxscrpt/definsfn.h>
#else
#include <maxscript/maxscript.h>
#include <maxscript/util/Listener.h>
#include <maxscript/foundation/numbers.h>
#endif

#include <rw.h>
#include <src/gtaplg.h>

#include "dffimp_res.h"

#define MAP_EXTRACOLORS -1
#define MAP_TEXCOORD0 1
#define MAP_EXTRAALPHA 9

#define lprintf the_listener->edit_stream->printf
#define lflush the_listener->edit_stream->flush

rw::Geometry *convertGeometry(INode *node);

enum RwMat {
	mat_color = 0, mat_coloralpha,
	mat_sp_ambient, mat_sp_diffuse, mat_sp_specular,
	mat_texmap_texture,

	/* matfx */
	mat_matfxeffect,
	mat_texmap_envmap, mat_envmap_amount,
	mat_texmap_bumpmap, mat_bumpmap_amount,
	mat_texmap_pass2, mat_pass2_srcblend, mat_pass2_destblend
};

enum RsExt {
	mat_enEnv = 0, mat_enSpec,
	mat_scaleX, mat_scaleY, mat_transScaleX, mat_transScaleY, mat_shininess,
	mat_specularity, mat_specMap
};

class DFFImport : public SceneImport
{
	Interface *ifc;
	ImpInterface *impifc;

public:
	static int convertAxes;
	static int autoSmooth;
	static int prepend;

	void makeMaterials(rw::Atomic *a, INode *inode);
	void makeMesh(rw::Atomic *a, Mesh *maxmesh);
	BOOL dffFileRead(const TCHAR *filename);

	DFFImport();
	~DFFImport();
	int ExtCount();				// Number of extensions supported
	const TCHAR *Ext(int n);		// Extension #n (i.e. "3DS")
	const TCHAR *LongDesc();		// Long ASCII description (i.e. "Autodesk 3D Studio File")
	const TCHAR *ShortDesc();		// Short ASCII description (i.e. "3D Studio")
	const TCHAR *AuthorName();		// ASCII Author name
	const TCHAR *CopyrightMessage();	// ASCII Copyright message
	const TCHAR *OtherMessage1();		// Other message #1
	const TCHAR *OtherMessage2();		// Other message #2
	unsigned int Version();			// Version number * 100 (i.e. v3.01 = 301)
	void ShowAbout(HWND hWnd);		// Show DLL's "About..." box
	int DoImport(const TCHAR *name,ImpInterface *ii, Interface *i, BOOL suppressPrompts=FALSE);	// Import file
};

extern int rwInitialized;
void initRW(void);
void initImporter(void);
